import { runInAction } from 'mobx';
import renderer, { getRoot } from './renderer';
if (typeof window !== 'undefined') {
  window.SimulatorRenderer = renderer;
}
window.addEventListener('beforeunload', function () {
  runInAction(function () {
    var _renderer$dispose;
    window.LCSimulatorHost = null;
    (_renderer$dispose = renderer.dispose) === null || _renderer$dispose === void 0 ? void 0 : _renderer$dispose.call(renderer);
    window.SimulatorRenderer = null;
    var root = getRoot();
    if (root) {
      root.unmount();
    } else {
      window.ReactDOM.unmountComponentAtNode(document.getElementById('root'));
    }
  });
});
export default renderer;