import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/objectWithoutPropertiesLoose";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _extends from "@babel/runtime/helpers/extends";
import _createClass from "@babel/runtime/helpers/createClass";
import _asyncToGenerator from "@babel/runtime/helpers/asyncToGenerator";
var _excluded = ["__id", "__designMode"];
import _regeneratorRuntime from "@babel/runtime/regenerator";
import React, { createElement } from 'react';
import { host } from './host';
import SimulatorRendererView from './renderer-view';
import { computed, observable as obx, untracked, makeObservable, configure } from 'mobx';
import { getClientRects as _getClientRects } from './utils/get-client-rects';
import { reactFindDOMNodes, getReactInternalFiber } from './utils/react-find-dom-nodes';
import { isElement, cursor, setNativeSelection as _setNativeSelection, buildComponents as _buildComponents, getSubComponent, compatibleLegaoSchema, isPlainObject, AssetLoader, getProjectUtils } from '@gant-lowcode/lowcode-utils';
import { IPublicEnumTransformStage } from '@gant-lowcode/lowcode-types';
// just use types

import LowCodeRenderer from '@gant-lowcode/lowcode-react-renderer';
import { createMemoryHistory } from 'history';
import Slot from './builtin-components/slot';
import Leaf from './builtin-components/leaf';
import { withQueryParams, parseQuery } from './utils/url';
import { merge } from 'lodash';
export var rootCache = null;
export function reactRender(_x, _x2) {
  return _reactRender.apply(this, arguments);
}
function _reactRender() {
  _reactRender = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee3(element, container) {
    var ReactDOM, root;
    return _regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          if (!rootCache) {
            _context3.next = 3;
            break;
          }
          rootCache.render(element);
          return _context3.abrupt("return");
        case 3:
          ReactDOM = window.ReactDOM;
          if (ReactDOM !== null && ReactDOM !== void 0 && ReactDOM.createRoot) {
            root = ReactDOM.createRoot(container);
            rootCache = root;
            root.render(element);
          } else {
            // React 16 fallback
            ReactDOM.render(element, container);
          }
        case 5:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return _reactRender.apply(this, arguments);
}
export var getRoot = function getRoot() {
  return rootCache;
};
var loader = new AssetLoader();
configure({
  enforceActions: 'never'
});
export var DocumentInstance = /*#__PURE__*/function () {
  function DocumentInstance(container, document) {
    this.container = container;
    this.document = document;
    this.instancesMap = new Map();
    this.disposeFunctions = [];
    this._components = {};
    // context from: utils、constants、history、location、match
    this._appContext = {};
    this._designMode = 'design';
    this._requestHandlersMap = null;
    this._device = 'default';
    this._componentsMap = {};
    makeObservable(this, {
      _components: obx.ref,
      _appContext: obx.ref,
      _designMode: obx.ref,
      _requestHandlersMap: obx.ref,
      _device: obx.ref,
      _componentsMap: obx.ref,
      components: computed,
      context: computed,
      designMode: computed,
      requestHandlersMap: computed,
      device: computed,
      componentsMap: computed,
      suspended: computed,
      scope: computed
    });
  }
  var _proto = DocumentInstance.prototype;
  _proto.unmountInstance = function unmountInstance(id, instance) {
    var instances = this.instancesMap.get(id);
    if (instances) {
      var i = instances.indexOf(instance);
      if (i > -1) {
        instances.splice(i, 1);
        host.setInstance(this.document.id, id, instances);
      }
    }
  };
  _proto.mountInstance = function mountInstance(id, instance) {
    var docId = this.document.id;
    var instancesMap = this.instancesMap;
    if (instance == null) {
      var _instances = this.instancesMap.get(id);
      if (_instances) {
        _instances = _instances.filter(checkInstanceMounted);
        if (_instances.length > 0) {
          instancesMap.set(id, _instances);
          host.setInstance(this.document.id, id, _instances);
        } else {
          instancesMap["delete"](id);
          host.setInstance(this.document.id, id, null);
        }
      }
      return;
    }
    var unmountInstance = this.unmountInstance.bind(this);
    var origId = instance[SYMBOL_VNID];
    if (origId && origId !== id) {
      // 另外一个节点的 instance 在此被复用了，需要从原来地方卸载
      unmountInstance(origId, instance);
    }
    if (isElement(instance)) {
      cacheReactKey(instance);
    } else if (origId !== id) {
      // 涵盖 origId == null || origId !== id 的情况
      var origUnmount = instance.componentWillUnmount;
      if (origUnmount && origUnmount.origUnmount) {
        origUnmount = origUnmount.origUnmount;
      }
      // hack! delete instance from map
      var newUnmount = function newUnmount() {
        unmountInstance(id, instance);
        origUnmount && origUnmount.call(this);
      };
      newUnmount.origUnmount = origUnmount;
      instance.componentWillUnmount = newUnmount;
    }
    instance[SYMBOL_VNID] = id;
    instance[SYMBOL_VDID] = docId;
    var instances = this.instancesMap.get(id);
    if (instances) {
      var l = instances.length;
      instances = instances.filter(checkInstanceMounted);
      var updated = instances.length !== l;
      if (!instances.includes(instance)) {
        instances.push(instance);
        updated = true;
      }
      if (!updated) {
        return;
      }
    } else {
      instances = [instance];
    }
    instancesMap.set(id, instances);
    host.setInstance(this.document.id, id, instances);
  };
  _proto.mountContext = function mountContext() {};
  _proto.getNode = function getNode(id) {
    return this.document.getNode(id);
  };
  _proto.dispose = function dispose() {
    this.disposeFunctions.forEach(function (fn) {
      return fn();
    });
    this.instancesMap = new Map();
  };
  return _createClass(DocumentInstance, [{
    key: "schema",
    get: function get() {
      return this.document["export"](IPublicEnumTransformStage.Render);
    }
  }, {
    key: "components",
    get: function get() {
      // 根据 device 选择不同组件，进行响应式
      // 更好的做法是，根据 device 选择加载不同的组件资源，甚至是 simulatorUrl
      return this._components;
    }
  }, {
    key: "context",
    get: function get() {
      return this._appContext;
    }
  }, {
    key: "designMode",
    get: function get() {
      return this._designMode;
    }
  }, {
    key: "requestHandlersMap",
    get: function get() {
      return this._requestHandlersMap;
    }
  }, {
    key: "device",
    get: function get() {
      return this._device;
    }
  }, {
    key: "componentsMap",
    get: function get() {
      return this._componentsMap;
    }
  }, {
    key: "suspended",
    get: function get() {
      return false;
    }
  }, {
    key: "scope",
    get: function get() {
      return null;
    }
  }, {
    key: "path",
    get: function get() {
      return "/" + this.document.fileName;
    }
  }, {
    key: "id",
    get: function get() {
      return this.document.id;
    }
  }]);
}();
export var SimulatorRendererContainer = /*#__PURE__*/function () {
  function SimulatorRendererContainer() {
    var _this = this;
    this.isSimulatorRenderer = true;
    this.disposeFunctions = [];
    this.history = void 0;
    this._documentInstances = [];
    this._requestHandlersMap = void 0;
    this._layout = null;
    this._libraryMap = {};
    this._components = {};
    // context from: utils、constants、history、location、match
    this._appContext = {};
    this._designMode = 'design';
    this._device = 'default';
    this._locale = undefined;
    this._componentsMap = {};
    /**
     * 是否为画布自动渲染
     */
    this.autoRender = true;
    /**
     * 画布是否自动监听事件来重绘节点
     */
    this.autoRepaintNode = true;
    this._running = false;
    makeObservable(this, {
      _documentInstances: obx.ref,
      _layout: obx,
      _appContext: obx.ref,
      _designMode: obx.ref,
      _device: obx.ref,
      _locale: obx.ref,
      _componentsMap: obx.ref,
      layout: computed,
      context: computed,
      designMode: computed,
      device: computed,
      locale: computed,
      componentsMap: computed
    });
    this.autoRender = host.autoRender;
    this.disposeFunctions.push(host.connect(this, function () {
      // sync layout config
      _this._layout = host.project.get('config').layout;

      // todo: split with others, not all should recompute
      if (_this._libraryMap !== host.libraryMap || _this._componentsMap !== host.designer.componentsMap) {
        _this._libraryMap = host.libraryMap || {};
        _this._componentsMap = host.designer.componentsMap;
        _this.buildComponents();
      }

      // sync designMode
      _this._designMode = host.designMode;
      _this._locale = host.locale;

      // sync requestHandlersMap
      _this._requestHandlersMap = host.requestHandlersMap;

      // sync device
      _this._device = host.device;
    }));
    var documentInstanceMap = new Map();
    var initialEntry = '/';
    var firstRun = true;
    this.disposeFunctions.push(host.autorun(function () {
      _this._documentInstances = host.project.documents.map(function (doc) {
        var inst = documentInstanceMap.get(doc.id);
        if (!inst) {
          inst = new DocumentInstance(_this, doc);
          documentInstanceMap.set(doc.id, inst);
        }
        return inst;
      });
      var path = host.project.currentDocument ? documentInstanceMap.get(host.project.currentDocument.id).path : '/';
      if (firstRun) {
        initialEntry = path;
        firstRun = false;
      } else if (_this.history.location.pathname !== path) {
        _this.history.replace(path);
      }
    }));
    var history = createMemoryHistory({
      initialEntries: [initialEntry]
    });
    this.history = history;
    history.listen(function (location) {
      var docId = location.pathname.slice(1);
      docId && host.project.open(docId);
    });
    host.componentsConsumer.consume(/*#__PURE__*/function () {
      var _ref = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee(componentsAsset) {
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!componentsAsset) {
                _context.next = 4;
                break;
              }
              _context.next = 3;
              return _this.load(componentsAsset);
            case 3:
              _this.buildComponents();
            case 4:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }());
    this._appContext = {
      utils: _extends({
        router: {
          push: function push(path, params) {
            history.push(withQueryParams(path, params));
          },
          replace: function replace(path, params) {
            history.replace(withQueryParams(path, params));
          }
        },
        legaoBuiltins: {
          getUrlParams: function getUrlParams() {
            var search = history.location.search;
            return parseQuery(search);
          }
        },
        i18n: {
          setLocale: function setLocale(loc) {
            _this._appContext.utils.i18n.currentLocale = loc;
            _this._locale = loc;
          },
          currentLocale: this.locale,
          messages: {}
        }
      }, getProjectUtils(this._libraryMap, host.get('utilsMetadata'))),
      constants: {},
      requestHandlersMap: this._requestHandlersMap
    };
    host.injectionConsumer.consume(function (data) {
      // TODO: sync utils, i18n, contants,... config
      var newCtx = _extends({}, _this._appContext);
      merge(newCtx, data.appHelper || {});
      _this._appContext = newCtx;
    });
    host.i18nConsumer.consume(function (data) {
      var newCtx = _extends({}, _this._appContext);
      newCtx.utils.i18n.messages = data || {};
      _this._appContext = newCtx;
    });
  }
  var _proto2 = SimulatorRendererContainer.prototype;
  _proto2.buildComponents = function buildComponents() {
    this._components = _buildComponents(this._libraryMap, this._componentsMap, this.createComponent.bind(this));
    this._components = _extends({}, builtinComponents, this._components);
  }

  /**
   * 加载资源
   */;
  _proto2.load = function load(asset) {
    return loader.load(asset);
  };
  _proto2.loadAsyncLibrary = /*#__PURE__*/function () {
    var _loadAsyncLibrary = _asyncToGenerator(/*#__PURE__*/_regeneratorRuntime.mark(function _callee2(asyncLibraryMap) {
      return _regeneratorRuntime.wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return loader.loadAsyncLibrary(asyncLibraryMap);
          case 2:
            this.buildComponents();
          case 3:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function loadAsyncLibrary(_x4) {
      return _loadAsyncLibrary.apply(this, arguments);
    }
    return loadAsyncLibrary;
  }();
  _proto2.getComponent = function getComponent(componentName) {
    var paths = componentName.split('.');
    var subs = [];
    while (true) {
      var _this$_components;
      var component = (_this$_components = this._components) === null || _this$_components === void 0 ? void 0 : _this$_components[componentName];
      if (component) {
        return getSubComponent(component, subs);
      }
      var sub = paths.pop();
      if (!sub) {
        return null;
      }
      subs.unshift(sub);
      componentName = paths.join('.');
    }
  };
  _proto2.getClosestNodeInstance = function getClosestNodeInstance(from, nodeId) {
    return _getClosestNodeInstance(from, nodeId);
  };
  _proto2.findDOMNodes = function findDOMNodes(instance) {
    return reactFindDOMNodes(instance);
  };
  _proto2.getClientRects = function getClientRects(element) {
    return _getClientRects(element);
  };
  _proto2.setNativeSelection = function setNativeSelection(enableFlag) {
    _setNativeSelection(enableFlag);
  };
  _proto2.setDraggingState = function setDraggingState(state) {
    cursor.setDragging(state);
  };
  _proto2.setCopyState = function setCopyState(state) {
    cursor.setCopy(state);
  };
  _proto2.clearState = function clearState() {
    cursor.release();
  };
  _proto2.createComponent = function createComponent(schema) {
    var _schema = _extends({}, schema, {
      componentsTree: schema.componentsTree.map(compatibleLegaoSchema)
    });
    var componentsTreeSchema = _schema.componentsTree[0];
    if (componentsTreeSchema.componentName === 'Component' && componentsTreeSchema.css) {
      var doc = window.document;
      var s = doc.createElement('style');
      s.setAttribute('type', 'text/css');
      s.setAttribute('id', "Component-" + (componentsTreeSchema.id || ''));
      s.appendChild(doc.createTextNode(componentsTreeSchema.css || ''));
      doc.getElementsByTagName('head')[0].appendChild(s);
    }
    var renderer = this;
    var LowCodeComp = /*#__PURE__*/function (_React$Component) {
      function LowCodeComp() {
        return _React$Component.apply(this, arguments) || this;
      }
      _inheritsLoose(LowCodeComp, _React$Component);
      var _proto3 = LowCodeComp.prototype;
      _proto3.render = function render() {
        var extraProps = getLowCodeComponentProps(this.props);
        return /*#__PURE__*/createElement(LowCodeRenderer, _extends({}, extraProps, {
          // 防止覆盖下面内置属性
          // 使用 _schema 为了使低代码组件在页面设计中使用变量，同 react 组件使用效果一致
          schema: componentsTreeSchema,
          components: renderer.components,
          designMode: '',
          locale: renderer.locale,
          messages: _schema.i18n || {},
          device: renderer.device,
          appHelper: renderer.context,
          rendererName: 'LowCodeRenderer',
          thisRequiredInJSE: host.thisRequiredInJSE,
          faultComponent: host.faultComponent,
          faultComponentMap: host.faultComponentMap,
          customCreateElement: function customCreateElement(Comp, props, children) {
            var _host$currentDocument;
            var componentMeta = (_host$currentDocument = host.currentDocument) === null || _host$currentDocument === void 0 ? void 0 : _host$currentDocument.getComponentMeta(Comp.displayName);
            if (componentMeta !== null && componentMeta !== void 0 && componentMeta.isModal) {
              return null;
            }
            var __id = props.__id,
              __designMode = props.__designMode,
              viewProps = _objectWithoutPropertiesLoose(props, _excluded);
            // mock _leaf，减少性能开销
            var _leaf = {
              isEmpty: function isEmpty() {
                return false;
              },
              isMock: true
            };
            viewProps._leaf = _leaf;
            return /*#__PURE__*/createElement(Comp, viewProps, children);
          }
        }));
      };
      return LowCodeComp;
    }(React.Component);
    return LowCodeComp;
  };
  _proto2.run = function run() {
    if (this._running) {
      return;
    }
    this._running = true;
    var containerId = 'root';
    var container = document.getElementById(containerId);
    if (!container) {
      container = document.createElement('div');
      document.body.appendChild(container);
      container.id = containerId;
    }

    // ==== compatible vision
    document.documentElement.classList.add('engine-page');
    document.body.classList.add('engine-document'); // important! Stylesheet.invoke depends

    reactRender(/*#__PURE__*/createElement(SimulatorRendererView, {
      rendererContainer: this
    }), container);
    host.project.setRendererReady(this);
  }

  /**
   * 刷新渲染器
   */;
  _proto2.rerender = function rerender() {
    this.autoRender = true;
    // TODO: 不太优雅
    this._appContext = _extends({}, this._appContext);
  };
  _proto2.stopAutoRepaintNode = function stopAutoRepaintNode() {
    this.autoRepaintNode = false;
  };
  _proto2.enableAutoRepaintNode = function enableAutoRepaintNode() {
    this.autoRepaintNode = true;
  };
  _proto2.dispose = function dispose() {
    var _this2 = this;
    this.disposeFunctions.forEach(function (fn) {
      return fn();
    });
    this.documentInstances.forEach(function (docInst) {
      return docInst.dispose();
    });
    untracked(function () {
      _this2._componentsMap = {};
      _this2._components = null;
      _this2._appContext = null;
    });
  };
  return _createClass(SimulatorRendererContainer, [{
    key: "documentInstances",
    get: function get() {
      return this._documentInstances;
    }
  }, {
    key: "layout",
    get: function get() {
      // TODO: parse layout Component
      return this._layout;
    },
    set: function set(value) {
      this._layout = value;
    }
  }, {
    key: "components",
    get: function get() {
      // 根据 device 选择不同组件，进行响应式
      // 更好的做法是，根据 device 选择加载不同的组件资源，甚至是 simulatorUrl
      return this._components || {};
    }
  }, {
    key: "context",
    get: function get() {
      return this._appContext;
    }
  }, {
    key: "designMode",
    get: function get() {
      return this._designMode;
    }
  }, {
    key: "device",
    get: function get() {
      return this._device;
    }
  }, {
    key: "locale",
    get: function get() {
      return this._locale;
    }
  }, {
    key: "componentsMap",
    get: function get() {
      return this._componentsMap;
    }
  }]);
}();

// Slot/Leaf and Fragment|FunctionComponent polyfill(ref)

var builtinComponents = {
  Slot: Slot,
  Leaf: Leaf
};
var REACT_KEY = '';
function cacheReactKey(el) {
  if (REACT_KEY !== '') {
    return el;
  }
  // react17 采用 __reactFiber 开头
  REACT_KEY = Object.keys(el).find(function (key) {
    return key.startsWith('__reactInternalInstance$') || key.startsWith('__reactFiber$');
  }) || '';
  if (!REACT_KEY && el.parentElement) {
    return cacheReactKey(el.parentElement);
  }
  return el;
}
var SYMBOL_VNID = Symbol('_LCNodeId');
var SYMBOL_VDID = Symbol('_LCDocId');
function _getClosestNodeInstance(from, specId) {
  var el = from;
  if (el) {
    if (isElement(el)) {
      el = cacheReactKey(el);
    } else {
      return getNodeInstance(getReactInternalFiber(el), specId);
    }
  }
  while (el) {
    if (SYMBOL_VNID in el) {
      var nodeId = el[SYMBOL_VNID];
      var docId = el[SYMBOL_VDID];
      if (!specId || specId === nodeId) {
        return {
          docId: docId,
          nodeId: nodeId,
          instance: el
        };
      }
    }
    // get fiberNode from element
    if (el[REACT_KEY]) {
      return getNodeInstance(el[REACT_KEY], specId);
    }
    el = el.parentElement;
  }
  return null;
}
function getNodeInstance(fiberNode, specId) {
  var instance = fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode.stateNode;
  if (instance && SYMBOL_VNID in instance) {
    var nodeId = instance[SYMBOL_VNID];
    var docId = instance[SYMBOL_VDID];
    if (!specId || specId === nodeId) {
      return {
        docId: docId,
        nodeId: nodeId,
        instance: instance
      };
    }
  }
  if (!instance && !(fiberNode !== null && fiberNode !== void 0 && fiberNode["return"])) return null;
  return getNodeInstance(fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode["return"]);
}
function checkInstanceMounted(instance) {
  if (isElement(instance)) {
    return instance.parentElement != null && window.document.contains(instance);
  }
  return true;
}
function getLowCodeComponentProps(props) {
  if (!props || !isPlainObject(props)) {
    return props;
  }
  var newProps = {};
  Object.keys(props).forEach(function (k) {
    if (['children', 'componentId', '__designMode', '_componentName', '_leaf'].includes(k)) {
      return;
    }
    newProps[k] = props[k];
  });
  newProps['componentName'] = props['_componentName'];
  return newProps;
}
export default new SimulatorRendererContainer();