"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _reactRouterDom = require("react-router-dom");
var _classnames = _interopRequireDefault(require("classnames"));
var _lowcodeReactRenderer = _interopRequireDefault(require("@gant-lowcode/lowcode-react-renderer"));
var _mobxReact = require("mobx-react");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _lowcodeTypes = require("@gant-lowcode/lowcode-types");
var _host = require("./host");
var _misc = require("./utils/misc");
require("./renderer.less");
var _locale = require("./locale");
var _excluded = ["__id"];
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
console.log('--window--', window);
var SimulatorRendererView = (0, _mobxReact.observer)(function (_ref) {
  var rendererContainer = _ref.rendererContainer;
  return /*#__PURE__*/_react["default"].createElement(Layout, {
    rendererContainer: rendererContainer
  }, /*#__PURE__*/_react["default"].createElement(_reactRouterDom.BrowserRouter, {
    basename: window.location.pathname
  }, /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Routes, null, rendererContainer.documentInstances.map(function (instance, index) {
    return /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, {
      index: index === 0,
      path: instance.path,
      key: instance.id,
      element: /*#__PURE__*/_react["default"].createElement(Renderer, {
        documentInstance: instance,
        rendererContainer: rendererContainer
      })
    });
  }), /*#__PURE__*/_react["default"].createElement(_reactRouterDom.Route, {
    path: "*",
    element: /*#__PURE__*/_react["default"].createElement("div", null, "\u8DEF\u7531\u5339\u914D\u9519\u8BEF")
  }))));
});
var _default = exports["default"] = SimulatorRendererView;
function ucfirst(s) {
  return s.charAt(0).toUpperCase() + s.substring(1);
}
function getDeviceView(view, device, mode) {
  if (!view || typeof view === 'string') {
    return view;
  }

  // compatible vision Mobile | Preview
  device = ucfirst(device);
  if (device === 'Mobile' && view.hasOwnProperty(device)) {
    view = view[device];
  }
  mode = ucfirst(mode);
  if (mode === 'Preview' && view.hasOwnProperty(mode)) {
    view = view[mode];
  }
  return view;
}
var Layout = (0, _mobxReact.observer)(function (_ref2) {
  var rendererContainer = _ref2.rendererContainer,
    children = _ref2.children;
  var layout = rendererContainer.layout;
  if (layout) {
    var Component = layout.Component,
      props = layout.props,
      componentName = layout.componentName;
    if (Component) {
      return /*#__PURE__*/_react["default"].createElement(Component, {
        key: "layout",
        props: props
      }, children);
    }
    if (componentName && rendererContainer.getComponent(componentName)) {
      var LayoutComponent = rendererContainer.getComponent(componentName);
      return /*#__PURE__*/_react["default"].createElement(LayoutComponent, (0, _extends2["default"])({
        key: "layout"
      }, props, {
        rendererContainer: rendererContainer
      }), children);
    }
  }
  return children;
});
var Renderer = (0, _mobxReact.observer)(function (_ref3) {
  var _container$context, _container$context$ut, _container$context$ut2;
  var rendererContainer = _ref3.rendererContainer,
    documentInstance = _ref3.documentInstance;
  var startTimeRef = (0, _react.useRef)(null);
  var schemaChangedSymbolRef = (0, _react.useRef)(false);
  var container = documentInstance.container,
    document = documentInstance.document;
  var designMode = container.designMode,
    device = container.device,
    locale = container.locale;
  var messages = ((_container$context = container.context) === null || _container$context === void 0 ? void 0 : (_container$context$ut = _container$context.utils) === null || _container$context$ut === void 0 ? void 0 : (_container$context$ut2 = _container$context$ut.i18n) === null || _container$context$ut2 === void 0 ? void 0 : _container$context$ut2.messages) || {};
  var _createIntl = (0, _locale.createIntl)(locale),
    intl = _createIntl.intl;
  var recordTime = function recordTime() {
    if (startTimeRef.current) {
      var _host$designer$curren, _host$designer$curren2, _host$designer$editor;
      var time = Date.now() - startTimeRef.current;
      var nodeCount = (_host$designer$curren = _host.host.designer.currentDocument) === null || _host$designer$curren === void 0 ? void 0 : (_host$designer$curren2 = _host$designer$curren.getNodeCount) === null || _host$designer$curren2 === void 0 ? void 0 : _host$designer$curren2.call(_host$designer$curren);
      (_host$designer$editor = _host.host.designer.editor) === null || _host$designer$editor === void 0 ? void 0 : _host$designer$editor.eventBus.emit(_lowcodeTypes.GlobalEvent.Node.Rerender, {
        componentName: 'Renderer',
        type: 'All',
        time: time,
        nodeCount: nodeCount
      });
    }
  };
  (0, _react.useEffect)(function () {
    recordTime();
  });

  // 初始化渲染时间
  startTimeRef.current = Date.now();
  schemaChangedSymbolRef.current = false;
  if (!container.autoRender || (0, _misc.isRendererDetached)()) {
    return null;
  }
  return /*#__PURE__*/_react["default"].createElement(_lowcodeReactRenderer["default"], {
    locale: locale,
    messages: messages,
    schema: documentInstance.schema,
    components: container.components,
    appHelper: container.context,
    designMode: designMode,
    device: device,
    documentId: document.id,
    suspended: rendererContainer.suspended,
    self: rendererContainer.scope,
    getSchemaChangedSymbol: function getSchemaChangedSymbol() {
      return schemaChangedSymbolRef.current;
    },
    setSchemaChangedSymbol: function setSchemaChangedSymbol(symbol) {
      return schemaChangedSymbolRef.current = symbol;
    },
    getNode: function getNode(id) {
      return documentInstance.getNode(id);
    },
    rendererName: "PageRenderer",
    notFoundComponent: _host.host.notFoundComponent,
    faultComponent: _host.host.faultComponent,
    faultComponentMap: _host.host.faultComponentMap,
    customCreateElement: function customCreateElement(Component, props, children) {
      var __id = props.__id,
        viewProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
      viewProps.componentId = __id;
      var leaf = documentInstance.getNode(__id);
      if ((0, _lowcodeUtils.isFromVC)(leaf === null || leaf === void 0 ? void 0 : leaf.componentMeta)) {
        viewProps._leaf = leaf.internalToShellNode();
      }
      viewProps._componentName = leaf === null || leaf === void 0 ? void 0 : leaf.componentName;
      // 如果是容器 && 无children && 高宽为空 增加一个占位容器，方便拖动
      if (!viewProps.dataSource && leaf !== null && leaf !== void 0 && leaf.isContainer() && (children == null || Array.isArray(children) && !children.length) && (!viewProps.style || Object.keys(viewProps.style).length === 0)) {
        var defaultPlaceholder = intl('Drag and drop components or templates here');
        var lockedNode = (0, _lowcodeUtils.getClosestNode)(leaf, function (node) {
          var _node$getExtraProp;
          return (node === null || node === void 0 ? void 0 : (_node$getExtraProp = node.getExtraProp('isLocked')) === null || _node$getExtraProp === void 0 ? void 0 : _node$getExtraProp.getValue()) === true;
        });
        if (lockedNode) {
          defaultPlaceholder = intl('Locked elements and child elements cannot be edited');
        }
        children = /*#__PURE__*/_react["default"].createElement("div", {
          className: (0, _classnames["default"])('lc-container-placeholder', {
            'lc-container-locked': !!lockedNode
          }),
          style: viewProps.placeholderStyle
        }, viewProps.placeholder || defaultPlaceholder);
      }
      if (viewProps._componentName === 'a') {
        delete viewProps.href;
      }
      // FIXME: 渲染仍有问题
      if (viewProps._componentName === 'Menu') {
        Object.assign(viewProps, {
          _componentName: 'Menu',
          className: '_css_pesudo_menu_kbrzyh0f',
          context: {
            VE: window.VisualEngine
          },
          direction: undefined,
          events: {
            ignored: true
          },
          fieldId: 'menu_kbrzyh0f',
          footer: '',
          header: '',
          mode: 'inline',
          onItemClick: {
            ignored: true
          },
          onSelect: {
            ignored: true
          },
          popupAlign: 'follow',
          selectMode: false,
          triggerType: 'click'
        });
      }
      if (!(0, _lowcodeUtils.isReactComponent)(Component)) {
        console.error(viewProps._componentName + " is not a react component!");
        return null;
      }
      return /*#__PURE__*/(0, _react.createElement)(getDeviceView(Component, device, designMode), viewProps, leaf !== null && leaf !== void 0 && leaf.isContainer() ? children == null ? [] : Array.isArray(children) ? children : [children] : children);
    },
    __host: _host.host,
    __container: container,
    onCompGetRef: function onCompGetRef(schema, ref) {
      documentInstance.mountInstance(schema.id, ref);
    },
    enableStrictNotFoundMode: _host.host.enableStrictNotFoundMode
  });
});