"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.getRoot = exports["default"] = exports.SimulatorRendererContainer = exports.DocumentInstance = void 0;
exports.reactRender = reactRender;
exports.rootCache = void 0;
var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var _react = _interopRequireWildcard(require("react"));
var _host = require("./host");
var _rendererView = _interopRequireDefault(require("./renderer-view"));
var _mobx = require("mobx");
var _getClientRects2 = require("./utils/get-client-rects");
var _reactFindDomNodes = require("./utils/react-find-dom-nodes");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
var _lowcodeTypes = require("@gant-lowcode/lowcode-types");
var _lowcodeReactRenderer = _interopRequireDefault(require("@gant-lowcode/lowcode-react-renderer"));
var _history = require("history");
var _slot = _interopRequireDefault(require("./builtin-components/slot"));
var _leaf2 = _interopRequireDefault(require("./builtin-components/leaf"));
var _url = require("./utils/url");
var _lodash = require("lodash");
var _excluded = ["__id", "__designMode"]; // just use types
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }
var rootCache = exports.rootCache = null;
function reactRender(_x, _x2) {
  return _reactRender.apply(this, arguments);
}
function _reactRender() {
  _reactRender = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee3(element, container) {
    var ReactDOM, root;
    return _regenerator["default"].wrap(function _callee3$(_context3) {
      while (1) switch (_context3.prev = _context3.next) {
        case 0:
          if (!rootCache) {
            _context3.next = 3;
            break;
          }
          rootCache.render(element);
          return _context3.abrupt("return");
        case 3:
          ReactDOM = window.ReactDOM;
          if (ReactDOM !== null && ReactDOM !== void 0 && ReactDOM.createRoot) {
            root = ReactDOM.createRoot(container);
            exports.rootCache = rootCache = root;
            root.render(element);
          } else {
            // React 16 fallback
            ReactDOM.render(element, container);
          }
        case 5:
        case "end":
          return _context3.stop();
      }
    }, _callee3);
  }));
  return _reactRender.apply(this, arguments);
}
var getRoot = exports.getRoot = function getRoot() {
  return rootCache;
};
var loader = new _lowcodeUtils.AssetLoader();
(0, _mobx.configure)({
  enforceActions: 'never'
});
var DocumentInstance = exports.DocumentInstance = /*#__PURE__*/function () {
  function DocumentInstance(container, document) {
    this.container = container;
    this.document = document;
    this.instancesMap = new Map();
    this.disposeFunctions = [];
    this._components = {};
    // context from: utils、constants、history、location、match
    this._appContext = {};
    this._designMode = 'design';
    this._requestHandlersMap = null;
    this._device = 'default';
    this._componentsMap = {};
    (0, _mobx.makeObservable)(this, {
      _components: _mobx.observable.ref,
      _appContext: _mobx.observable.ref,
      _designMode: _mobx.observable.ref,
      _requestHandlersMap: _mobx.observable.ref,
      _device: _mobx.observable.ref,
      _componentsMap: _mobx.observable.ref,
      components: _mobx.computed,
      context: _mobx.computed,
      designMode: _mobx.computed,
      requestHandlersMap: _mobx.computed,
      device: _mobx.computed,
      componentsMap: _mobx.computed,
      suspended: _mobx.computed,
      scope: _mobx.computed
    });
  }
  var _proto = DocumentInstance.prototype;
  _proto.unmountInstance = function unmountInstance(id, instance) {
    var instances = this.instancesMap.get(id);
    if (instances) {
      var i = instances.indexOf(instance);
      if (i > -1) {
        instances.splice(i, 1);
        _host.host.setInstance(this.document.id, id, instances);
      }
    }
  };
  _proto.mountInstance = function mountInstance(id, instance) {
    var docId = this.document.id;
    var instancesMap = this.instancesMap;
    if (instance == null) {
      var _instances = this.instancesMap.get(id);
      if (_instances) {
        _instances = _instances.filter(checkInstanceMounted);
        if (_instances.length > 0) {
          instancesMap.set(id, _instances);
          _host.host.setInstance(this.document.id, id, _instances);
        } else {
          instancesMap["delete"](id);
          _host.host.setInstance(this.document.id, id, null);
        }
      }
      return;
    }
    var unmountInstance = this.unmountInstance.bind(this);
    var origId = instance[SYMBOL_VNID];
    if (origId && origId !== id) {
      // 另外一个节点的 instance 在此被复用了，需要从原来地方卸载
      unmountInstance(origId, instance);
    }
    if ((0, _lowcodeUtils.isElement)(instance)) {
      cacheReactKey(instance);
    } else if (origId !== id) {
      // 涵盖 origId == null || origId !== id 的情况
      var origUnmount = instance.componentWillUnmount;
      if (origUnmount && origUnmount.origUnmount) {
        origUnmount = origUnmount.origUnmount;
      }
      // hack! delete instance from map
      var newUnmount = function newUnmount() {
        unmountInstance(id, instance);
        origUnmount && origUnmount.call(this);
      };
      newUnmount.origUnmount = origUnmount;
      instance.componentWillUnmount = newUnmount;
    }
    instance[SYMBOL_VNID] = id;
    instance[SYMBOL_VDID] = docId;
    var instances = this.instancesMap.get(id);
    if (instances) {
      var l = instances.length;
      instances = instances.filter(checkInstanceMounted);
      var updated = instances.length !== l;
      if (!instances.includes(instance)) {
        instances.push(instance);
        updated = true;
      }
      if (!updated) {
        return;
      }
    } else {
      instances = [instance];
    }
    instancesMap.set(id, instances);
    _host.host.setInstance(this.document.id, id, instances);
  };
  _proto.mountContext = function mountContext() {};
  _proto.getNode = function getNode(id) {
    return this.document.getNode(id);
  };
  _proto.dispose = function dispose() {
    this.disposeFunctions.forEach(function (fn) {
      return fn();
    });
    this.instancesMap = new Map();
  };
  return (0, _createClass2["default"])(DocumentInstance, [{
    key: "schema",
    get: function get() {
      return this.document["export"](_lowcodeTypes.IPublicEnumTransformStage.Render);
    }
  }, {
    key: "components",
    get: function get() {
      // 根据 device 选择不同组件，进行响应式
      // 更好的做法是，根据 device 选择加载不同的组件资源，甚至是 simulatorUrl
      return this._components;
    }
  }, {
    key: "context",
    get: function get() {
      return this._appContext;
    }
  }, {
    key: "designMode",
    get: function get() {
      return this._designMode;
    }
  }, {
    key: "requestHandlersMap",
    get: function get() {
      return this._requestHandlersMap;
    }
  }, {
    key: "device",
    get: function get() {
      return this._device;
    }
  }, {
    key: "componentsMap",
    get: function get() {
      return this._componentsMap;
    }
  }, {
    key: "suspended",
    get: function get() {
      return false;
    }
  }, {
    key: "scope",
    get: function get() {
      return null;
    }
  }, {
    key: "path",
    get: function get() {
      return "/" + this.document.fileName;
    }
  }, {
    key: "id",
    get: function get() {
      return this.document.id;
    }
  }]);
}();
var SimulatorRendererContainer = exports.SimulatorRendererContainer = /*#__PURE__*/function () {
  function SimulatorRendererContainer() {
    var _this = this;
    this.isSimulatorRenderer = true;
    this.disposeFunctions = [];
    this.history = void 0;
    this._documentInstances = [];
    this._requestHandlersMap = void 0;
    this._layout = null;
    this._libraryMap = {};
    this._components = {};
    // context from: utils、constants、history、location、match
    this._appContext = {};
    this._designMode = 'design';
    this._device = 'default';
    this._locale = undefined;
    this._componentsMap = {};
    /**
     * 是否为画布自动渲染
     */
    this.autoRender = true;
    /**
     * 画布是否自动监听事件来重绘节点
     */
    this.autoRepaintNode = true;
    this._running = false;
    (0, _mobx.makeObservable)(this, {
      _documentInstances: _mobx.observable.ref,
      _layout: _mobx.observable,
      _appContext: _mobx.observable.ref,
      _designMode: _mobx.observable.ref,
      _device: _mobx.observable.ref,
      _locale: _mobx.observable.ref,
      _componentsMap: _mobx.observable.ref,
      layout: _mobx.computed,
      context: _mobx.computed,
      designMode: _mobx.computed,
      device: _mobx.computed,
      locale: _mobx.computed,
      componentsMap: _mobx.computed
    });
    this.autoRender = _host.host.autoRender;
    this.disposeFunctions.push(_host.host.connect(this, function () {
      // sync layout config
      _this._layout = _host.host.project.get('config').layout;

      // todo: split with others, not all should recompute
      if (_this._libraryMap !== _host.host.libraryMap || _this._componentsMap !== _host.host.designer.componentsMap) {
        _this._libraryMap = _host.host.libraryMap || {};
        _this._componentsMap = _host.host.designer.componentsMap;
        _this.buildComponents();
      }

      // sync designMode
      _this._designMode = _host.host.designMode;
      _this._locale = _host.host.locale;

      // sync requestHandlersMap
      _this._requestHandlersMap = _host.host.requestHandlersMap;

      // sync device
      _this._device = _host.host.device;
    }));
    var documentInstanceMap = new Map();
    var initialEntry = '/';
    var firstRun = true;
    this.disposeFunctions.push(_host.host.autorun(function () {
      _this._documentInstances = _host.host.project.documents.map(function (doc) {
        var inst = documentInstanceMap.get(doc.id);
        if (!inst) {
          inst = new DocumentInstance(_this, doc);
          documentInstanceMap.set(doc.id, inst);
        }
        return inst;
      });
      var path = _host.host.project.currentDocument ? documentInstanceMap.get(_host.host.project.currentDocument.id).path : '/';
      if (firstRun) {
        initialEntry = path;
        firstRun = false;
      } else if (_this.history.location.pathname !== path) {
        _this.history.replace(path);
      }
    }));
    var history = (0, _history.createMemoryHistory)({
      initialEntries: [initialEntry]
    });
    this.history = history;
    history.listen(function (location) {
      var docId = location.pathname.slice(1);
      docId && _host.host.project.open(docId);
    });
    _host.host.componentsConsumer.consume(/*#__PURE__*/function () {
      var _ref = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(componentsAsset) {
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (!componentsAsset) {
                _context.next = 4;
                break;
              }
              _context.next = 3;
              return _this.load(componentsAsset);
            case 3:
              _this.buildComponents();
            case 4:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }));
      return function (_x3) {
        return _ref.apply(this, arguments);
      };
    }());
    this._appContext = {
      utils: (0, _extends2["default"])({
        router: {
          push: function push(path, params) {
            history.push((0, _url.withQueryParams)(path, params));
          },
          replace: function replace(path, params) {
            history.replace((0, _url.withQueryParams)(path, params));
          }
        },
        legaoBuiltins: {
          getUrlParams: function getUrlParams() {
            var search = history.location.search;
            return (0, _url.parseQuery)(search);
          }
        },
        i18n: {
          setLocale: function setLocale(loc) {
            _this._appContext.utils.i18n.currentLocale = loc;
            _this._locale = loc;
          },
          currentLocale: this.locale,
          messages: {}
        }
      }, (0, _lowcodeUtils.getProjectUtils)(this._libraryMap, _host.host.get('utilsMetadata'))),
      constants: {},
      requestHandlersMap: this._requestHandlersMap
    };
    _host.host.injectionConsumer.consume(function (data) {
      // TODO: sync utils, i18n, contants,... config
      var newCtx = (0, _extends2["default"])({}, _this._appContext);
      (0, _lodash.merge)(newCtx, data.appHelper || {});
      _this._appContext = newCtx;
    });
    _host.host.i18nConsumer.consume(function (data) {
      var newCtx = (0, _extends2["default"])({}, _this._appContext);
      newCtx.utils.i18n.messages = data || {};
      _this._appContext = newCtx;
    });
  }
  var _proto2 = SimulatorRendererContainer.prototype;
  _proto2.buildComponents = function buildComponents() {
    this._components = (0, _lowcodeUtils.buildComponents)(this._libraryMap, this._componentsMap, this.createComponent.bind(this));
    this._components = (0, _extends2["default"])({}, builtinComponents, this._components);
  }

  /**
   * 加载资源
   */;
  _proto2.load = function load(asset) {
    return loader.load(asset);
  };
  _proto2.loadAsyncLibrary = /*#__PURE__*/function () {
    var _loadAsyncLibrary = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee2(asyncLibraryMap) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) switch (_context2.prev = _context2.next) {
          case 0:
            _context2.next = 2;
            return loader.loadAsyncLibrary(asyncLibraryMap);
          case 2:
            this.buildComponents();
          case 3:
          case "end":
            return _context2.stop();
        }
      }, _callee2, this);
    }));
    function loadAsyncLibrary(_x4) {
      return _loadAsyncLibrary.apply(this, arguments);
    }
    return loadAsyncLibrary;
  }();
  _proto2.getComponent = function getComponent(componentName) {
    var paths = componentName.split('.');
    var subs = [];
    while (true) {
      var _this$_components;
      var component = (_this$_components = this._components) === null || _this$_components === void 0 ? void 0 : _this$_components[componentName];
      if (component) {
        return (0, _lowcodeUtils.getSubComponent)(component, subs);
      }
      var sub = paths.pop();
      if (!sub) {
        return null;
      }
      subs.unshift(sub);
      componentName = paths.join('.');
    }
  };
  _proto2.getClosestNodeInstance = function getClosestNodeInstance(from, nodeId) {
    return _getClosestNodeInstance(from, nodeId);
  };
  _proto2.findDOMNodes = function findDOMNodes(instance) {
    return (0, _reactFindDomNodes.reactFindDOMNodes)(instance);
  };
  _proto2.getClientRects = function getClientRects(element) {
    return (0, _getClientRects2.getClientRects)(element);
  };
  _proto2.setNativeSelection = function setNativeSelection(enableFlag) {
    (0, _lowcodeUtils.setNativeSelection)(enableFlag);
  };
  _proto2.setDraggingState = function setDraggingState(state) {
    _lowcodeUtils.cursor.setDragging(state);
  };
  _proto2.setCopyState = function setCopyState(state) {
    _lowcodeUtils.cursor.setCopy(state);
  };
  _proto2.clearState = function clearState() {
    _lowcodeUtils.cursor.release();
  };
  _proto2.createComponent = function createComponent(schema) {
    var _schema = (0, _extends2["default"])({}, schema, {
      componentsTree: schema.componentsTree.map(_lowcodeUtils.compatibleLegaoSchema)
    });
    var componentsTreeSchema = _schema.componentsTree[0];
    if (componentsTreeSchema.componentName === 'Component' && componentsTreeSchema.css) {
      var doc = window.document;
      var s = doc.createElement('style');
      s.setAttribute('type', 'text/css');
      s.setAttribute('id', "Component-" + (componentsTreeSchema.id || ''));
      s.appendChild(doc.createTextNode(componentsTreeSchema.css || ''));
      doc.getElementsByTagName('head')[0].appendChild(s);
    }
    var renderer = this;
    var LowCodeComp = /*#__PURE__*/function (_React$Component) {
      function LowCodeComp() {
        return _React$Component.apply(this, arguments) || this;
      }
      (0, _inheritsLoose2["default"])(LowCodeComp, _React$Component);
      var _proto3 = LowCodeComp.prototype;
      _proto3.render = function render() {
        var extraProps = getLowCodeComponentProps(this.props);
        return /*#__PURE__*/(0, _react.createElement)(_lowcodeReactRenderer["default"], (0, _extends2["default"])({}, extraProps, {
          // 防止覆盖下面内置属性
          // 使用 _schema 为了使低代码组件在页面设计中使用变量，同 react 组件使用效果一致
          schema: componentsTreeSchema,
          components: renderer.components,
          designMode: '',
          locale: renderer.locale,
          messages: _schema.i18n || {},
          device: renderer.device,
          appHelper: renderer.context,
          rendererName: 'LowCodeRenderer',
          thisRequiredInJSE: _host.host.thisRequiredInJSE,
          faultComponent: _host.host.faultComponent,
          faultComponentMap: _host.host.faultComponentMap,
          customCreateElement: function customCreateElement(Comp, props, children) {
            var _host$currentDocument;
            var componentMeta = (_host$currentDocument = _host.host.currentDocument) === null || _host$currentDocument === void 0 ? void 0 : _host$currentDocument.getComponentMeta(Comp.displayName);
            if (componentMeta !== null && componentMeta !== void 0 && componentMeta.isModal) {
              return null;
            }
            var __id = props.__id,
              __designMode = props.__designMode,
              viewProps = (0, _objectWithoutPropertiesLoose2["default"])(props, _excluded);
            // mock _leaf，减少性能开销
            var _leaf = {
              isEmpty: function isEmpty() {
                return false;
              },
              isMock: true
            };
            viewProps._leaf = _leaf;
            return /*#__PURE__*/(0, _react.createElement)(Comp, viewProps, children);
          }
        }));
      };
      return LowCodeComp;
    }(_react["default"].Component);
    return LowCodeComp;
  };
  _proto2.run = function run() {
    if (this._running) {
      return;
    }
    this._running = true;
    var containerId = 'root';
    var container = document.getElementById(containerId);
    if (!container) {
      container = document.createElement('div');
      document.body.appendChild(container);
      container.id = containerId;
    }

    // ==== compatible vision
    document.documentElement.classList.add('engine-page');
    document.body.classList.add('engine-document'); // important! Stylesheet.invoke depends

    reactRender(/*#__PURE__*/(0, _react.createElement)(_rendererView["default"], {
      rendererContainer: this
    }), container);
    _host.host.project.setRendererReady(this);
  }

  /**
   * 刷新渲染器
   */;
  _proto2.rerender = function rerender() {
    this.autoRender = true;
    // TODO: 不太优雅
    this._appContext = (0, _extends2["default"])({}, this._appContext);
  };
  _proto2.stopAutoRepaintNode = function stopAutoRepaintNode() {
    this.autoRepaintNode = false;
  };
  _proto2.enableAutoRepaintNode = function enableAutoRepaintNode() {
    this.autoRepaintNode = true;
  };
  _proto2.dispose = function dispose() {
    var _this2 = this;
    this.disposeFunctions.forEach(function (fn) {
      return fn();
    });
    this.documentInstances.forEach(function (docInst) {
      return docInst.dispose();
    });
    (0, _mobx.untracked)(function () {
      _this2._componentsMap = {};
      _this2._components = null;
      _this2._appContext = null;
    });
  };
  return (0, _createClass2["default"])(SimulatorRendererContainer, [{
    key: "documentInstances",
    get: function get() {
      return this._documentInstances;
    }
  }, {
    key: "layout",
    get: function get() {
      // TODO: parse layout Component
      return this._layout;
    },
    set: function set(value) {
      this._layout = value;
    }
  }, {
    key: "components",
    get: function get() {
      // 根据 device 选择不同组件，进行响应式
      // 更好的做法是，根据 device 选择加载不同的组件资源，甚至是 simulatorUrl
      return this._components || {};
    }
  }, {
    key: "context",
    get: function get() {
      return this._appContext;
    }
  }, {
    key: "designMode",
    get: function get() {
      return this._designMode;
    }
  }, {
    key: "device",
    get: function get() {
      return this._device;
    }
  }, {
    key: "locale",
    get: function get() {
      return this._locale;
    }
  }, {
    key: "componentsMap",
    get: function get() {
      return this._componentsMap;
    }
  }]);
}(); // Slot/Leaf and Fragment|FunctionComponent polyfill(ref)
var builtinComponents = {
  Slot: _slot["default"],
  Leaf: _leaf2["default"]
};
var REACT_KEY = '';
function cacheReactKey(el) {
  if (REACT_KEY !== '') {
    return el;
  }
  // react17 采用 __reactFiber 开头
  REACT_KEY = Object.keys(el).find(function (key) {
    return key.startsWith('__reactInternalInstance$') || key.startsWith('__reactFiber$');
  }) || '';
  if (!REACT_KEY && el.parentElement) {
    return cacheReactKey(el.parentElement);
  }
  return el;
}
var SYMBOL_VNID = Symbol('_LCNodeId');
var SYMBOL_VDID = Symbol('_LCDocId');
function _getClosestNodeInstance(from, specId) {
  var el = from;
  if (el) {
    if ((0, _lowcodeUtils.isElement)(el)) {
      el = cacheReactKey(el);
    } else {
      return getNodeInstance((0, _reactFindDomNodes.getReactInternalFiber)(el), specId);
    }
  }
  while (el) {
    if (SYMBOL_VNID in el) {
      var nodeId = el[SYMBOL_VNID];
      var docId = el[SYMBOL_VDID];
      if (!specId || specId === nodeId) {
        return {
          docId: docId,
          nodeId: nodeId,
          instance: el
        };
      }
    }
    // get fiberNode from element
    if (el[REACT_KEY]) {
      return getNodeInstance(el[REACT_KEY], specId);
    }
    el = el.parentElement;
  }
  return null;
}
function getNodeInstance(fiberNode, specId) {
  var instance = fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode.stateNode;
  if (instance && SYMBOL_VNID in instance) {
    var nodeId = instance[SYMBOL_VNID];
    var docId = instance[SYMBOL_VDID];
    if (!specId || specId === nodeId) {
      return {
        docId: docId,
        nodeId: nodeId,
        instance: instance
      };
    }
  }
  if (!instance && !(fiberNode !== null && fiberNode !== void 0 && fiberNode["return"])) return null;
  return getNodeInstance(fiberNode === null || fiberNode === void 0 ? void 0 : fiberNode["return"]);
}
function checkInstanceMounted(instance) {
  if ((0, _lowcodeUtils.isElement)(instance)) {
    return instance.parentElement != null && window.document.contains(instance);
  }
  return true;
}
function getLowCodeComponentProps(props) {
  if (!props || !(0, _lowcodeUtils.isPlainObject)(props)) {
    return props;
  }
  var newProps = {};
  Object.keys(props).forEach(function (k) {
    if (['children', 'componentId', '__designMode', '_componentName', '_leaf'].includes(k)) {
      return;
    }
    newProps[k] = props[k];
  });
  newProps['componentName'] = props['_componentName'];
  return newProps;
}
var _default = exports["default"] = new SimulatorRendererContainer();